Index: /trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 20030)
+++ /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 20031)
@@ -3337,5 +3337,5 @@
       <link to="VirtualSystemDescriptionType" /> enum value in the array item in aTypes[]. In each case,
       the array item with the same index in aOvfValues[] will contain the original value as contained
-      in the OVF file (just for informational purposes), and the corresponding item in aVboxValues[]
+      in the OVF file (just for informational purposes), and the corresponding item in aVBoxValues[]
       will contain a suggested value to be used for VirtualBox. Depending on the description type,
       the aExtraConfigValues[] array item may also be used.
@@ -3344,5 +3344,5 @@
       <li>
         "OS": the guest operating system type. There must be exactly one such array item on import. The
-        corresponding item in aVboxValues[] contains the suggested guest operating system for VirtualBox.
+        corresponding item in aVBoxValues[] contains the suggested guest operating system for VirtualBox.
         This will be one of the values listed in <link to="IVirtualBox::guestOSTypes" />. The corresponding
         item in aOvfValues[] will contain a numerical value that described the operating system in the OVF
@@ -3353,5 +3353,5 @@
         if none is present on import, then an automatic name will be created from the operating system
         type. The correponding item im aOvfValues[] will contain the suggested virtual machine name
-        from the OVF file, and aVboxValues[] will contain a suggestion for a unique VirtualBox
+        from the OVF file, and aVBoxValues[] will contain a suggestion for a unique VirtualBox
         <link to="IMachine" /> name that does not exist yet.
       </li>
@@ -3376,5 +3376,5 @@
       <li>
         "HarddiskControllerIDE": an IDE hard disk controller. There can be at most one such item. This
-        has no value in aOvfValues[] or aVboxValues[].
+        has no value in aOvfValues[] or aVBoxValues[].
         The matching item in the aRefs[] array will contain an integer that items of the "Harddisk"
         type can use to specify which hard disk controller a virtual disk should be connected to.
@@ -3382,10 +3382,10 @@
       <li>
         "HarddiskControllerSATA": an SATA hard disk controller. There can be at most one such item. This
-        has no value in aOvfValues[] or aVboxValues[].
+        has no value in aOvfValues[] or aVBoxValues[].
         The matching item in the aRefs[] array will be used as with IDE controllers (see above).
       </li>
       <li>
         "HarddiskControllerSCSI": a SCSI hard disk controller. There can be at most one such item.
-        The items in aOvfValues[] and aVboxValues[] will either be "LsiLogic" or "BusLogic".
+        The items in aOvfValues[] and aVBoxValues[] will either be "LsiLogic" or "BusLogic".
         The matching item in the aRefs[] array will be used as with IDE controllers (see above).
       </li>
@@ -3396,5 +3396,5 @@
         The array item in aOvfValues[] will contain the file specification from the OVF file (without
         a path since the image file should be in the same location as the OVF file itself), whereas the
-        item in aVboxValues[] will contain a qualified path specification to where VirtualBox uses the
+        item in aVBoxValues[] will contain a qualified path specification to where VirtualBox uses the
         hard disk image. This means that on import the image will be copied and converted from the
         "ovf" location to the "vbox" location; on export, this will be handled the other way round.
@@ -3412,5 +3412,5 @@
       </li>
       <li>
-        "NetworkAdapter": a network adapter. The array item in aVboxValues[] will specify the hardware
+        "NetworkAdapter": a network adapter. The array item in aVBoxValues[] will specify the hardware
         for the network adapter, whereas the array item in aExtraConfigValues[] will have a string
         of the "type=&lt;X&gt;" format, where &lt;X&gt; must be either "NAT" or "Bridged".
@@ -3442,5 +3442,5 @@
       </param>
 
-      <param name="aVboxValues" type="wstring" dir="out" safearray="yes">
+      <param name="aVBoxValues" type="wstring" dir="out" safearray="yes">
         <desc></desc>
       </param>
@@ -3472,5 +3472,5 @@
       </param>
 
-      <param name="aVboxValues" type="wstring" dir="out" safearray="yes">
+      <param name="aVBoxValues" type="wstring" dir="out" safearray="yes">
         <desc></desc>
       </param>
@@ -3514,5 +3514,5 @@
 
         For the "vbox" and "extra configuration" values, if you pass in the same arrays
-        as returned in the aVboxValues and aExtraConfigValues arrays from getDescription(),
+        as returned in the aVBoxValues and aExtraConfigValues arrays from getDescription(),
         the configuration remains unchanged. Please see the documentation for getDescription()
         for valid configuration values for the individual array item types. If the
@@ -3524,5 +3524,5 @@
       </param>
 
-      <param name="aVboxValues" type="wstring" dir="in" safearray="yes">
+      <param name="aVBoxValues" type="wstring" dir="in" safearray="yes">
         <desc></desc>
       </param>
@@ -3545,5 +3545,5 @@
       </param>
 
-      <param name="aVboxValue" type="wstring" dir="in">
+      <param name="aVBoxValue" type="wstring" dir="in">
         <desc></desc>
       </param>