Index: trunk/src/VBox/Main/ApplianceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 20211)
+++ trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 20212)
@@ -4000,5 +4000,5 @@
     }
     // report result of asynchronous operation
-    LONG iRc;
+    ULONG iRc;
     rc = pProgressAsync->COMGETTER(ResultCode)(&iRc);
     if (FAILED(rc)) throw rc;
Index: trunk/src/VBox/Main/HostPower.cpp
===================================================================
--- trunk/src/VBox/Main/HostPower.cpp	(revision 20211)
+++ trunk/src/VBox/Main/HostPower.cpp	(revision 20212)
@@ -136,5 +136,5 @@
 
                 /* Wait until the operation has been completed. */
-                LONG iRc;
+                ULONG iRc;
                 rc = progress->WaitForCompletion(-1);
                 if (SUCCEEDED (rc))
Index: trunk/src/VBox/Main/ProgressImpl.cpp
===================================================================
--- trunk/src/VBox/Main/ProgressImpl.cpp	(revision 20211)
+++ trunk/src/VBox/Main/ProgressImpl.cpp	(revision 20212)
@@ -372,5 +372,5 @@
 }
 
-STDMETHODIMP ProgressBase::COMGETTER(ResultCode) (LONG *aResultCode)
+STDMETHODIMP ProgressBase::COMGETTER(ResultCode) (ULONG *aResultCode)
 {
     CheckComArgOutPointerValid(aResultCode);
@@ -492,8 +492,7 @@
     AssertReturn (aProgress != NULL, E_INVALIDARG);
 
-    LONG iRc;
-    HRESULT rc = aProgress->COMGETTER(ResultCode) (&iRc);
+    ULONG resultCode;
+    HRESULT rc = aProgress->COMGETTER(ResultCode) (&resultCode);
     AssertComRCReturnRC (rc);
-    HRESULT resultCode = iRc;
 
     if (resultCode == S_OK)
@@ -1316,5 +1315,5 @@
 }
 
-STDMETHODIMP CombinedProgress::COMGETTER(ResultCode) (LONG *aResultCode)
+STDMETHODIMP CombinedProgress::COMGETTER(ResultCode) (ULONG *aResultCode)
 {
     CheckComArgOutPointerValid(aResultCode);
@@ -1593,9 +1592,7 @@
                 return rc;
 
-            LONG iRc;
-            rc = progress->COMGETTER(ResultCode) (&iRc);
+            rc = progress->COMGETTER(ResultCode) (&mResultCode);
             if (FAILED (rc))
                 return rc;
-            mResultCode = iRc;
 
             if (FAILED (mResultCode))
Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 20211)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 20212)
@@ -8031,5 +8031,5 @@
     </attribute>
 
-    <attribute name="resultCode" type="long" readonly="yes">
+    <attribute name="resultCode" type="unsigned long" readonly="yes">
       <desc>
         Result code of the progress task.
Index: trunk/src/VBox/Main/include/ProgressImpl.h
===================================================================
--- trunk/src/VBox/Main/include/ProgressImpl.h	(revision 20211)
+++ trunk/src/VBox/Main/include/ProgressImpl.h	(revision 20212)
@@ -76,5 +76,5 @@
     STDMETHOD(COMGETTER(Completed)) (BOOL *aCompleted);
     STDMETHOD(COMGETTER(Canceled)) (BOOL *aCanceled);
-    STDMETHOD(COMGETTER(ResultCode)) (LONG *aResultCode);
+    STDMETHOD(COMGETTER(ResultCode)) (ULONG *aResultCode);
     STDMETHOD(COMGETTER(ErrorInfo)) (IVirtualBoxErrorInfo **aErrorInfo);
     STDMETHOD(COMGETTER(OperationCount)) (ULONG *aOperationCount);
@@ -396,5 +396,5 @@
     STDMETHOD(COMGETTER(Completed)) (BOOL *aCompleted);
     STDMETHOD(COMGETTER(Canceled)) (BOOL *aCanceled);
-    STDMETHOD(COMGETTER(ResultCode)) (LONG *aResultCode);
+    STDMETHOD(COMGETTER(ResultCode)) (ULONG *aResultCode);
     STDMETHOD(COMGETTER(ErrorInfo)) (IVirtualBoxErrorInfo **aErrorInfo);
     STDMETHOD(COMGETTER(Operation)) (ULONG *aCount);
Index: trunk/src/VBox/Main/testcase/tstVBoxAPILinux.cpp
===================================================================
--- trunk/src/VBox/Main/testcase/tstVBoxAPILinux.cpp	(revision 20211)
+++ trunk/src/VBox/Main/testcase/tstVBoxAPILinux.cpp	(revision 20212)
@@ -326,5 +326,5 @@
              */
             rc = progress->WaitForCompletion(-1);
-            PRInt32 resultCode;
+            PRUint32 resultCode;
             progress->GetResultCode(&resultCode);
             if (NS_FAILED(rc) || NS_FAILED(resultCode))